#include <math.h>
#include <stdio.h>
#include <inttypes.h>

#define PI atan2 (0.0, -1.0)

const double d = 4.0;

//#include "icosaeder.h"
#include "cylinder.h"
//#include "elite.h"
//#include "cube.h"

int main () {
    int i, l, lnum, frame;
    double deg_x = 0.0;
    double deg_y = 0.0;
    double deg_z = 0.0;

    double t_x[num_vertices];
    double t_y[num_vertices];

    double x, y, z;
    double x_, y_, z_;

    double v0_x, v1_x, v2_x, v3_x;
    double v0_y, v1_y, v2_y, v3_y;

    double sam;

    uint8_t bits[7];

    uint8_t byte, first;

    int pos;

    uint8_t lines_x1[8192];
    uint8_t lines_y1[8192];
    uint8_t lines_x2[8192];
    uint8_t lines_y2[8192];

    uint8_t last_x2;
    uint8_t last_y2;

    int frames = 256;

    for (frame = 0; frame < frames; frame++) {
//      for (i = 0; i < 10; i++) {
//          pos = frame % 12;
//          faces[i + 8 ][4] = swirl[pos + i];
//          faces[i + 18][4] = swirl[pos + i];
//      }

        deg_x = (2.0 * PI * frame * 3.0) / (double)frames;
        deg_y = (2.0 * PI * frame * 2.0) / (double)frames;
        deg_z = (2.0 * PI * frame * 1.0) / (double)frames;

        for (i = 0; i < num_vertices; i++) {
            //rotate this shit
            x_ = vertx[i] * cosf(deg_z) - verty[i] * sinf(deg_z);
            y_ = vertx[i] * sinf(deg_z) + verty[i] * cosf(deg_z);

            x = x_;
            y = y_;

            y_ = y * cosf(deg_y) - vertz[i] * sinf(deg_y);
            z_ = y * sinf(deg_y) + vertz[i] * cosf(deg_y);

            y = y_;
            z = z_;

            x_ = z * sinf(deg_x) + x * cosf(deg_x);
            z_ = z * cosf(deg_x) - x * sinf(deg_x);

            //perspective
            t_x[i] = (x_ / (1.0 + z_ / d)) * scaling + 64.0;
            t_y[i] = (y_ / (1.0 + z_ / d)) * scaling + 64.0;
        }

        lnum = 0;
        //get all visible lines
        for (i = 0; i < num_faces; i++) {
            //for a better overview copy stuff
            v0_x = t_x[faces[i][0]];
            v1_x = t_x[faces[i][1]];
            v2_x = t_x[faces[i][2]];
            v3_x = t_x[faces[i][3]];

            v0_y = t_y[faces[i][0]];
            v1_y = t_y[faces[i][1]];
            v2_y = t_y[faces[i][2]];
            v3_y = t_y[faces[i][3]];

            //culling via signed area
            sam = (v1_y - v0_y) * (v2_x - v1_x) - (v1_x - v0_x) * (v2_y - v1_y);
            if(sam > 0) {
                //add each line to list if visible and valid
                if(faces[i][5+0]) {
                    lines_x1[lnum] = v0_x;
                    lines_y1[lnum] = v0_y;
                    lines_x2[lnum] = v1_x;
                    lines_y2[lnum] = v1_y;
                    lnum++;
                }
                if(faces[i][5+1]) {
                    lines_x1[lnum] = v1_x;
                    lines_y1[lnum] = v1_y;
                    lines_x2[lnum] = v2_x;
                    lines_y2[lnum] = v2_y;
                    lnum++;
                }
                if(faces[i][5+2]) {
                    lines_x1[lnum] = v2_x;
                    lines_y1[lnum] = v2_y;
                    lines_x2[lnum] = v3_x;
                    lines_y2[lnum] = v3_y;
                    lnum++;
                }
                if(faces[i][5+3]) {
                    lines_x1[lnum] = v3_x;
                    lines_y1[lnum] = v3_y;
                    lines_x2[lnum] = v0_x;
                    lines_y2[lnum] = v0_y;
                    lnum++;
                }
            }
        }

        last_x2 = 0xfe;
        last_y2 = 0xfe;

        for (l = 0; l < lnum; l++) {
            //zero length lines?
            if (lines_x1[l] == lines_x2[l] && lines_y1[l] == lines_y2[l]) {
                lines_x1[l] = 0xff;
                lines_y1[l] = 0xff;
                lines_x2[l] = 0xff;
                lines_y2[l] = 0xff;
            //check for doublicates and wipe them out
            } else {
                for (i = l + 1; i < lnum; i++) {
                    if ( (lines_x1[i] == lines_x1[l] && lines_y1[i] == lines_y1[l] && lines_x2[i] == lines_x2[l] && lines_y2[i] == lines_y2[l]) ||
                         (lines_x1[i] == lines_x2[l] && lines_y1[i] == lines_y2[l] && lines_x2[i] == lines_x1[l] && lines_y2[i] == lines_y1[l])) {
//                        if (frame == 0) printf("%d\n", i);
                        lines_x1[l] = 0xff;
                        lines_y1[l] = 0xff;
                        lines_x2[l] = 0xff;
                        lines_y2[l] = 0xff;
                    }
                }
            }
        }

        while (1) {
            for (l = 0; l < lnum; l++) {
                //only check valid lines
                if (lines_x1[l] != 0xff) {
                    if (lines_x1[l] == last_x2 && lines_y1[l] == last_y2) {
                        //flag that first coordinates can be reused
                        printf("!byte $%02x, $%02x\n", lines_x2[l] | 0x80, lines_y2[l]);
                        last_x2 = lines_x2[l];
                        last_y2 = lines_y2[l];
                        lines_x1[l] = 0xff;
                        lines_y1[l] = 0xff;
                        lines_x2[l] = 0xff;
                        lines_y2[l] = 0xff;
                        break;
                    }
                }
            }
            if (l == lnum) {
                //seems like no match was found, so start with a new full line
                for (l = 0; l < lnum; l++) {
                    //only check valid lines
                    if (lines_x1[l] != 0xff) {
                        printf("!byte $%02x, $%02x, $%02x, $%02x\n", lines_x1[l], lines_y1[l], lines_x2[l], lines_y2[l]);
                        last_x2 = lines_x2[l];
                        last_y2 = lines_y2[l];
                        lines_x1[l] = 0xff;
                        lines_y1[l] = 0xff;
                        lines_x2[l] = 0xff;
                        lines_y2[l] = 0xff;
                        break;
                    }
                }
            }
            if (l == lnum) break;
        }

        printf("!byte $ff\n");
    }
    return 0;
}
