!cpu 6510
!ifdef MUSIC {
         * = $1000
!bin "oldschool7.prg",,2
}

         * = $3800

bank1      = $2800
bank2      = $3000

s_line     = $10

data       = $02
dst        = $04

x1         = $06
x2         = $07
y1         = $08
y2         = $09

dy         = $0a
xoff       = $0b
block      = $0c
err        = $0d
bank       = $0e
dxdy       = $0f

src        = x1

USE_DEY    = 1
USE_INY    = 0

;DEBUG_SPACE
;BIG_FRAMES
;MOVE
;SYNC

fcnt       = $fe

!ifdef MUSIC {
         lda #$00
         tax
         tay
         jsr $1000
}
         sei
         lda #$7f
         sta $dc0d
         lda $dc0d
         lda #$01
         sta $d019
         sta $d01a
         lda #$fb
         sta $d012
         lda $d011
         and #$7f
         sta $d011
         lda #<irq
         sta $fffe
         lda #>irq
         sta $ffff

         lda #$1a
         sta $d018

         ldx #$00
-
         lda #$0b
         sta $d800,x
         sta $d900,x
         sta $da00,x
         sta $db00,x
         lda #$00
         sta $0400,x
         sta $0500,x
         sta $0600,x
         sta $0700,x
         sta bank1+$000,x
         sta bank1+$100,x
         sta bank1+$200,x
         sta bank1+$300,x
         sta bank1+$400,x
         sta bank1+$500,x
         sta bank1+$600,x
         sta bank1+$700,x
         sta bank2+$000,x
         sta bank2+$100,x
         sta bank2+$200,x
         sta bank2+$300,x
         sta bank2+$400,x
         sta bank2+$500,x
         sta bank2+$600,x
         sta bank2+$700,x
         dex
         bne -

         lda #$0f
         sta $d020
         sta $d021

         ldx #$00
-
         lda code_start,x
         sta s_line,x
         inx
         cpx #code_end-code_start
         bne -

!ifndef MOVE {
         ldx #$10
         ldy #$0c
         jsr move_bank1
         lda #$08
         sta $d016
}
         lda #$34
         sta $01

         jsr gen_clear

         cli
         jmp start

code_start
!pseudopc s_line {
inc_line
i_pixm=*+1
         lda #$00        ;2
i_dst1 = * + 1
         ora $2800,y     ;4 do a normal plot
i_dst2 = * + 1
         sta $2800,y     ;5
         dey             ;2
         bmi out
         txa
dx=*+1
         sbx #$00
         bcs inc_line

         lsr+1 i_pixm
         bcs i_colch
i_back
         lda+1 i_pixm
         ora (i_dst1),y
         sta (i_dst1),y
         dey
         bmi out
         txa
i_dxdy=*+1
         sbx #$00         ;combine add dx and sbc dy in one command
         bcs inc_line
         lsr+1 i_pixm
         bcc i_back
i_colch
         lda #$80
         sta+1 i_pixm
         eor+1 i_dst1
         sta+1 i_dst1
         sta+1 i_dst2
         bmi i_back
         inc+1 i_dst1+1
         inc+1 i_dst2+1
         bne i_back

dec_line
d_pixm=*+1
         lda #$00
d_dst1   ora $2800,y
d_dst2   sta $2800,y
         dey
         bmi out
         txa
ddx=*+1
         sbx #$00
         bcs dec_line
d_back
         lda (d_dst1+1),y
         slo+1 d_pixm
         bcs d_colch
         sta (d_dst1+1),y
         dey
         bmi out
d_back2
         txa
d_dxdy=*+1
         sbx #$00
         bcs dec_line
         bcc d_back
d_colch
         lda #$80
         eor d_dst1+1
         sta d_dst1+1
         sta d_dst2+1
         bpl +
         dec d_dst1+2
         dec d_dst2+2
+
         lda #$01
         sta d_pixm
         ora (d_dst1+1),y
         sta (d_dst1+1),y
         dey
         bpl d_back2
out
         jmp loop_back
}
code_end

loop_plot
         ora (dst),y
         sta (dst),y
loop_back
ytmp2    ldy #$00

loop
!ifdef BIG_FRAMES {
         ;take care that y does not overrun
         cpy #$80
         bcc +
         tya
         clc
         adc data
         sta data
         ldy #$00
         bcc +
         inc data+1
+
}
         lax (data),y
         ;now x = x1 as well
         bpl normal
         ;new frame?
         cmp #$ff
         ;nope, but reuse
         bne reuse
         ;yes

         ;a new frame starts, so add y to data pointer
         ;iny
         tya
         ;sec  ;carry is set, as we branch on equal to here
         adc data
         sta data
         bcc +
         inc data+1
+
         cmp #<meshend
         bne next_frame
         lda data+1
         cmp #>meshend
         bne next_frame
         jmp restart
reuse
         ;move x2/y2 -> x1/y1
         ldx y2
         stx y1
         ldx x2
         stx x1
         ;now x = x1

         and #$7f
         jmp loop2
start

         lda #$00
         sta dst
         sta bank
restart
         lda #$00
         sta $0f12
         jsr timer_read
         lda #<meshdata
         sta data
         lda #>meshdata
         sta data+1
next_frame
!ifdef DEBUG_SPACE {
         inc $01
         lda #$10

         bit $dc01
         bne *-3

         bit $dc01
         beq *-3
         dec $01
}
!ifdef SYNC {
         inc $01
-
         lda $d012
         cmp #$40
         bcc +
         cmp #$b8
         bcc -
+
         dec $01
}
         jmp switch_bank

normal
         iny
         stx x1
         lda (data),y
         iny
         sta y1
         lda (data),y
loop2
         iny
         sta x2
         lda (data),y
         sta y2
         iny
         sty ytmp2+1

         lda y1
         sec
         sbc y2
         bcs +
         jmp swapped
+
         sta dy
         ;->y2 < y1

         lda x1
         sbc x2
         bcs dec_x_dec_y
         eor #$ff
         adc #$01
         sec
inc_x_dec_y
         sta dx
         sbc dy
         bcs f_line_inc
         jmp s_line_inc

         ;-> x2 < x1
dec_x_dec_y
         sta dx
         sbc dy
         bcs f_line_dec
         jmp s_line_dec


f_line_dec
         sta dxdy

         ldy x1

bnk1     lda xposh,y
         sta dst+1

         lax x2
         and #$07
         sta xoff
         asl
         sta fl8_jmp+1

         lda bl_tab+8,y   ;last block number -> +8 to compensate cleared carry
         ;sec
         sbc bl_tab,x     ;first block number
         beq +
         sta block        ;store number of blocks
         lda and7asl,y    ;select entry pointer depening on x-position within starting column
         sta jmp1+1

         ;y will be freely decremented
         lda y1
         ora xposl,y      ;add lowbyte to y start position to avoid page crossing on ora/sta (dst),y
         tay

         ;initial error
         lda dx
         lsr
         sec
         sbc dy
         ;enter blockcode @ right position
jmp1     jmp (pixtab)

         ;XXX TODO reuse same combined code?
         ;combined
+
         lax dx
         and #$07
         asl
         adc #$10
         sta jmp5+1

         lda y1
         ora xposl,y
         tay

         ;initial error
         txa
         lsr
         sec
         sbc dy
         ldx xoff
         ;enter blockcode @ right position
jmp5     jmp (pixtab)


f_line_inc
         ;x2 > x1
         sta dxdy

         ldy x1
bnk3     lda xposh,y
         sta dst+1
         lax x2
         and #$07
         sta xoff
         asl
         ora #$10
         sta fil8_jmp+1

         lda bl_tab+8,x     ;last block number -> +8 to compensate cleared carry
         ;sec
         sbc bl_tab,y     ;first block number
         beq +
         sta block        ;store number of blocks
         lda and7asl2,y   ;select entry pointer depening on x-position within starting column
         sta jmp3+1

         lda y1
         ora xposl,y      ;add lowbyte to y start position to avoid page crossing on ora/sta (dst),y
         tay

         ;initial error
         lda dx
         lsr
         sec
         sbc dy
         ;enter blockcode @ right position
jmp3     jmp (pixtab)
         ;combined
+
         lax dx
         and #$07
         asl
         adc #$30
         sta jmp7+1

         lda y1
         ora xposl,y
         tay

         ;initial error
         txa
         lsr
         sec
         sbc dy
         ldx xoff
         ;enter blockcode @ right position
jmp7     jmp (pixtab)



swapped
         ;swap
         eor #$ff
         adc #$01
         sta dy

         lda x2
         sec
         sbc x1
         bcs sdec_x_dec_y
         eor #$ff
         adc #$01
         sec
sinc_x_dec_y
         sta dx
         sbc dy
         bcs sf_line_inc
         jmp ss_line_inc
sdec_x_dec_y
         sta dx
         sbc dy
         bcs sf_line_dec
         jmp ss_line_dec

sf_line_dec
         sta dxdy

         ldy x2

bnk2     lda xposh,y
         sta dst+1

         ;ldy x1
         txa
         and #$07
         sta xoff
         asl
         sta fl8_jmp+1

         lda bl_tab+8,y   ;last block number -> +8 to compensate cleared carry
         ;sec
         sbc bl_tab,x     ;first block number
         beq +
         sta block        ;store number of blocks
         lda and7asl,y    ;select entry pointer depening on x-position within starting column
         sta jmp2+1

         lda y2
         ora xposl,y      ;add lowbyte to y start position to avoid page crossing on ora/sta (dst),y
         tay

         ;initial error
         lda dx
         lsr
         sec
         sbc dy
         ;enter blockcode @ right position
jmp2     jmp (pixtab)
         ;combined
+
         lax dx
         and #$07
         asl
         adc #$10
         sta jmp6+1

         lda y2
         ora xposl,y
         tay

         ;initial error
         txa
         lsr
         sec
         sbc dy
         ldx xoff
         ;enter blockcode @ right position
jmp6     jmp (pixtab)


sf_line_inc
         sta dxdy

         ldy x2
bnk4     lda xposh,y
         sta dst+1
         ;lax x1
         txa
         and #$07
         sta xoff
         asl
         ora #$10
         sta fil8_jmp+1

         lda bl_tab+8,x   ;last block number -> +8 to compensate cleared carry
         ;sec
         sbc bl_tab,y     ;first block number
         beq +
         sta block        ;store number of blocks
         lda and7asl2,y   ;select entry pointer depening on x-position within starting column
         sta jmp4+1

         lda y2
         ora xposl,y      ;add lowbyte to y start position to avoid page crossing on ora/sta (dst),y
         tay

         ;initial error
         lda dx
         lsr
         sec
         sbc dy
         ;enter blockcode @ right position
jmp4     jmp (pixtab)
         ;combined
+
         lax dx
         and #$07
         asl
         adc #$30
         sta jmp8+1

         lda y2
         ora xposl,y
         tay

         ;initial error
         txa
         lsr
         sec
         sbc dy
         ldx xoff
         ;enter blockcode @ right position
jmp8     jmp (pixtab)


s_line_dec
         sta d_dxdy
         ;ldx x1

         ;y2 will be added to dst, now we can decrement dy until -1
         lda y2
         ora xposl,x
         sta+1 d_dst1+1
         sta+1 d_dst2+1

bnk5     lda xposh,x
         sta+1 d_dst1+2
         sta+1 d_dst2+2

         lda mask,x
         sta+1 d_pixm

         lda dx
         sta ddx

         lda dy
         tay
         lsr
         tax

         jmp dec_line

s_line_inc
         sta i_dxdy
         ;ldx x1

         ;y2 will be added to dst, now we can decrement dy until -1
         lda y2
         ora xposl,x
         sta+1 i_dst1
         sta+1 i_dst2

bnk7     lda xposh,x
         sta+1 i_dst1+1
         sta+1 i_dst2+1

         lda mask,x
         sta+1 i_pixm

         lda dy
         tay
         lsr
         tax

         jmp inc_line

ss_line_dec
         sta d_dxdy
         ldx x2

         ;y2 will be added to dst, now we can decrement dy until -1
         lda y1
         ora xposl,x
         sta+1 d_dst1+1
         sta+1 d_dst2+1

bnk6     lda xposh,x
         sta+1 d_dst1+2
         sta+1 d_dst2+2

         lda mask,x
         sta+1 d_pixm

         lda dx
         sta ddx

         lda dy
         tay
         lsr
         tax

         jmp dec_line


ss_line_inc
         sta i_dxdy
         ldx x2

         ;y2 will be added to dst, now we can decrement dy until -1
         lda y1
         ora xposl,x
         sta+1 i_dst1
         sta+1 i_dst2

bnk8     lda xposh,x
         sta+1 i_dst1+1
         sta+1 i_dst2+1

         lda mask,x
         sta+1 i_pixm

         lda dy
         tay
         lsr
         tax

         jmp inc_line

switch_bank
         ldx #$1c
         lda bank
         tay
         beq +
         ldy #$80
         ldx #$1a
+
         inc $01
         stx $d018
         dec $01

         sty bnk1+1
         sty bnk2+1
         sty bnk3+1
         sty bnk4+1
         sty bnk5+1
         sty bnk6+1
         sty bnk7+1
         sty bnk8+1
clear
         eor #$01
         sta bank
         beq cl_bank2
         lda #$00
         jsr clear1
         jmp +
cl_bank2
clear2   jsr $1000
+
         ldy #$00
         jmp loop

;---------------------------------------
; code for flat lines (decrementing y)
;---------------------------------------

f8_new_column_y
         ora (dst),y
         sta (dst),y
         dey

         ;advance column
         tya
         eor #$80
         tay
         bpl +
         dec dst+1
         dec block
         bne f8_entry
-
         txa
         sec
         sbc+1 dy
         ldx xoff
fl8_jmp  jmp (fl8_tab)

;entry point for no y change
f8_new_column
         ora (dst),y
         sta (dst),y

         ;advance column
         tya
         eor #$80
         tay
         bpl +
         dec dst+1
+
         dec block
         beq -

;8 pixels to go
f8_entry
         txa
         sbc dy
         bcc f8_exit_1
         sbc dy
         bcc f8_exit_2
         sbc dy
         bcc f8_exit_3
         sbc dy
         bcc f8_exit_4
         sbc dy
         bcc f8_exit_5
         sbc dy
         bcc f8_exit_6
         sbc dy
         bcc f8_exit_7
         sbc dy
         bcc f8_exit_8
         tax
         lda #$ff
         jmp f8_new_column+2   ;nothing to ora, as all pixels will be set anyway!
f8_exit_8
         adc+1 dx
         tax
         lda #$ff
         jmp f8_new_column_y+2 ;same as above
f8_exit_2
         tax
         lda #$03
         jmp f6_entry_y
f8_exit_3
         tax
         lda #$07
         jmp f5_entry_y
f8_exit_4
         tax
         lda #$0f
         jmp f4_entry_y
f8_exit_5
         tax
         lda #$1f
         jmp f3_entry_y
f8_exit_6
         tax
         lda #$3f
         jmp f2_entry_y
f8_exit_7
         tax
         lda #$7f
         jmp f1_entry_y
f8_exit_1
         tax
         lda #$01

f7_entry_y
         ora (dst),y
         sta (dst),y
         dey
;7 pixels to go
f7_entry
         txa
         adc dxdy
         bcc f7_exit_1
         sbc dy
         bcc f7_exit_2
         sbc dy
         bcc f7_exit_3
         sbc dy
         bcc f7_exit_4
         sbc dy
         bcc f7_exit_5
         sbc dy
         bcc f7_exit_6
         sbc dy
         bcc f7_exit_7
         tax
         lda #$fe
         jmp f8_new_column
f7_exit_7
         adc dx
         tax
         lda #$fe
         jmp f8_new_column_y
f7_exit_2
         tax
         lda #$06
         jmp f5_entry_y
f7_exit_3
         tax
         lda #$0e
         jmp f4_entry_y
f7_exit_4
         tax
         lda #$1e
         jmp f3_entry_y
f7_exit_5
         tax
         lda #$3e
         jmp f2_entry_y
f7_exit_6
         tax
         lda #$7e
         jmp f1_entry_y
f7_exit_1
         tax
         lda #$02

f6_entry_y
         ora (dst),y
         sta (dst),y
         dey
;6 pixels to go
f6_entry
         txa
         adc dxdy
         bcc f6_exit_1
         sbc dy
         bcc f6_exit_2
         sbc dy
         bcc f6_exit_3
         sbc dy
         bcc f6_exit_4
         sbc dy
         bcc f6_exit_5
         sbc dy
         bcc f6_exit_6
         tax
         lda #$fc
         jmp f8_new_column
f6_exit_6
         adc dx
         tax
         lda #$fc
         jmp f8_new_column_y

f6_exit_2
         tax
         lda #$0c
         jmp f4_entry_y
f6_exit_3
         tax
         lda #$1c
         jmp f3_entry_y
f6_exit_4
         tax
         lda #$3c
         jmp f2_entry_y
f6_exit_5
         tax
         lda #$7c
         jmp f1_entry_y
f6_exit_1
         tax
         lda #$04

f5_entry_y
         ora (dst),y
         sta (dst),y
         dey
;5 pixels to go
f5_entry
         txa
         adc dxdy
         bcc f5_exit_1
         sbc dy
         bcc f5_exit_2
         sbc dy
         bcc f5_exit_3
         sbc dy
         bcc f5_exit_4
         sbc dy
         bcc f5_exit_5
         tax
         lda #$f8
         jmp f8_new_column
f5_exit_5
         adc dx
         tax
         lda #$f8
         jmp f8_new_column_y

f5_exit_2
         tax
         lda #$18
         jmp f3_entry_y
f5_exit_3
         tax
         lda #$38
         jmp f2_entry_y
f5_exit_4
         tax
         lda #$78
         jmp f1_entry_y
f5_exit_1
         tax
         lda #$08

f4_entry_y
         ora (dst),y
         sta (dst),y
         dey
;4 pixels to go
f4_entry
         txa
         adc dxdy
         bcc f4_exit_1
         sbc dy
         bcc f4_exit_2
         sbc dy
         bcc f4_exit_3
         sbc dy
         bcc f4_exit_4
         tax
         lda #$f0
         jmp f8_new_column
f4_exit_4
         adc dx
         tax
         lda #$f0
         jmp f8_new_column_y

f4_exit_2
         tax
         lda #$30
         jmp f2_entry_y
f4_exit_3
         tax
         lda #$70
         jmp f1_entry_y
f4_exit_1
         tax
         lda #$10

f3_entry_y
         ora (dst),y
         sta (dst),y
         dey
;3 pixels to go
f3_entry
         txa
         adc dxdy
         bcc f3_exit_1
         sbc dy
         bcc f3_exit_2
         sbc dy
         bcc f3_exit_3
         tax
         lda #$e0
         jmp f8_new_column
f3_exit_3
         adc dx
         tax
         lda #$e0
         jmp f8_new_column_y

f3_exit_2
         tax
         lda #$60
         jmp f1_entry_y
f3_exit_1
         tax
         lda #$20

f2_entry_y
         ora (dst),y
         sta (dst),y
         dey
;2 pixels to go
f2_entry
         txa
         adc dxdy
         bcc f2_exit_1
         sbc dy
         bcc f2_exit_2
         tax
         lda #$c0
         jmp f8_new_column
f2_exit_2
         adc dx
         tax
         lda #$c0
         jmp f8_new_column_y
f2_exit_1
         tax
         lda #$40

f1_entry_y
         ora (dst),y
         sta (dst),y
         dey
;1 pixel to go
f1_entry
         txa
         adc dxdy
         bcc f1_exit_1
         tax
         lda #$80
         jmp f8_new_column
f1_exit_1
         adc dx
         tax
         lda #$80
         jmp f8_new_column_y



fi8_new_column_y
         ora (dst),y
         sta (dst),y
         dey

         ;advance column
         tya
         eor #$80
         tay
         bmi +
         inc dst+1
         dec block
         bne fi8_entry
-
         txa
         sec
         sbc+1 dy
         ldx xoff
fil8_jmp jmp (fil8_tab)

;entry point for no y change
fi8_new_column
         ora (dst),y
         sta (dst),y

         ;advance column
         tya
         eor #$80
         tay
         bmi +
         inc dst+1
+
         dec block
         beq -

;8 pixels to go
fi8_entry
         txa
         sbc dy
         bcc fi8_exit_1
         sbc dy
         bcc fi8_exit_2
         sbc dy
         bcc fi8_exit_3
         sbc dy
         bcc fi8_exit_4
         sbc dy
         bcc fi8_exit_5
         sbc dy
         bcc fi8_exit_6
         sbc dy
         bcc fi8_exit_7
         sbc dy
         bcc fi8_exit_8
         tax
         lda #$ff
         jmp fi8_new_column+2   ;nothing to ora, as all pixels will be set anyway!
fi8_exit_8
         adc+1 dx
         tax
         lda #$ff
         jmp fi8_new_column_y+2 ;same as above
fi8_exit_2
         tax
         lda #$c0
         jmp fi6_entry_y
fi8_exit_3
         tax
         lda #$e0
         jmp fi5_entry_y
fi8_exit_4
         tax
         lda #$f0
         jmp fi4_entry_y
fi8_exit_5
         tax
         lda #$f8
         jmp fi3_entry_y
fi8_exit_6
         tax
         lda #$fc
         jmp fi2_entry_y
fi8_exit_7
         tax
         lda #$fe
         jmp fi1_entry_y
fi8_exit_1
         tax
         lda #$80

fi7_entry_y
         ora (dst),y
         sta (dst),y
         dey
;7 pixels to go
fi7_entry
         txa
         adc dxdy
         bcc fi7_exit_1
         sbc dy
         bcc fi7_exit_2
         sbc dy
         bcc fi7_exit_3
         sbc dy
         bcc fi7_exit_4
         sbc dy
         bcc fi7_exit_5
         sbc dy
         bcc fi7_exit_6
         sbc dy
         bcc fi7_exit_7
         tax
         lda #$7f
         jmp fi8_new_column
fi7_exit_7
         adc dx
         tax
         lda #$7f
         jmp fi8_new_column_y
fi7_exit_2
         tax
         lda #$60
         jmp fi5_entry_y
fi7_exit_3
         tax
         lda #$70
         jmp fi4_entry_y
fi7_exit_4
         tax
         lda #$78
         jmp fi3_entry_y
fi7_exit_5
         tax
         lda #$7c
         jmp fi2_entry_y
fi7_exit_6
         tax
         lda #$7e
         jmp fi1_entry_y
fi7_exit_1
         tax
         lda #$40

fi6_entry_y
         ora (dst),y
         sta (dst),y
         dey
;6 pixels to go
fi6_entry
         txa
         adc dxdy
         bcc fi6_exit_1
         sbc dy
         bcc fi6_exit_2
         sbc dy
         bcc fi6_exit_3
         sbc dy
         bcc fi6_exit_4
         sbc dy
         bcc fi6_exit_5
         sbc dy
         bcc fi6_exit_6
         tax
         lda #$3f
         jmp fi8_new_column
fi6_exit_6
         adc dx
         tax
         lda #$3f
         jmp fi8_new_column_y

fi6_exit_2
         tax
         lda #$30
         jmp fi4_entry_y
fi6_exit_3
         tax
         lda #$38
         jmp fi3_entry_y
fi6_exit_4
         tax
         lda #$3c
         jmp fi2_entry_y
fi6_exit_5
         tax
         lda #$3e
         jmp fi1_entry_y
fi6_exit_1
         tax
         lda #$20

fi5_entry_y
         ora (dst),y
         sta (dst),y
         dey
;5 pixels to go
fi5_entry
         txa
         adc dxdy
         bcc fi5_exit_1
         sbc dy
         bcc fi5_exit_2
         sbc dy
         bcc fi5_exit_3
         sbc dy
         bcc fi5_exit_4
         sbc dy
         bcc fi5_exit_5
         tax
         lda #$1f
         jmp fi8_new_column
fi5_exit_5
         adc dx
         tax
         lda #$1f
         jmp fi8_new_column_y

fi5_exit_2
         tax
         lda #$18
         jmp fi3_entry_y
fi5_exit_3
         tax
         lda #$1c
         jmp fi2_entry_y
fi5_exit_4
         tax
         lda #$1e
         jmp fi1_entry_y
fi5_exit_1
         tax
         lda #$10

fi4_entry_y
         ora (dst),y
         sta (dst),y
         dey
;4 pixels to go
fi4_entry
         txa
         adc dxdy
         bcc fi4_exit_1
         sbc dy
         bcc fi4_exit_2
         sbc dy
         bcc fi4_exit_3
         sbc dy
         bcc fi4_exit_4
         tax
         lda #$0f
         jmp fi8_new_column
fi4_exit_4
         adc dx
         tax
         lda #$0f
         jmp fi8_new_column_y

fi4_exit_2
         tax
         lda #$0c
         jmp fi2_entry_y
fi4_exit_3
         tax
         lda #$0e
         jmp fi1_entry_y
fi4_exit_1
         tax
         lda #$08

fi3_entry_y
         ora (dst),y
         sta (dst),y
         dey
;3 pixels to go
fi3_entry
         txa
         adc dxdy
         bcc fi3_exit_1
         sbc dy
         bcc fi3_exit_2
         sbc dy
         bcc fi3_exit_3
         tax
         lda #$07
         jmp fi8_new_column
fi3_exit_3
         adc dx
         tax
         lda #$07
         jmp fi8_new_column_y

fi3_exit_2
         tax
         lda #$06
         jmp fi1_entry_y
fi3_exit_1
         tax
         lda #$04

fi2_entry_y
         ora (dst),y
         sta (dst),y
         dey
;2 pixels to go
fi2_entry
         txa
         adc dxdy
         bcc fi2_exit_1
         sbc dy
         bcc fi2_exit_2
         tax
         lda #$03
         jmp fi8_new_column
fi2_exit_2
         adc dx
         tax
         lda #$03
         jmp fi8_new_column_y
fi2_exit_1
         tax
         lda #$02

fi1_entry_y
         ora (dst),y
         sta (dst),y
         dey
;1 pixel to go
fi1_entry
         txa
         adc dxdy
         bcc fi1_exit_1
         tax
         lda #$01
         jmp fi8_new_column
fi1_exit_1
         adc dx
         tax
         lda #$01
         jmp fi8_new_column_y



;entry point for y change
fl8_entry
         lda+1 err
         sbc+1 dy
         bcc fl8_exit_1
         sbc+1 dy
         bcc fl8_exit_2
         sbc+1 dy
         bcc fl8_exit_3
         sbc+1 dy
         bcc fl8_exit_4
         sbc+1 dy
         bcc fl8_exit_5
         sbc+1 dy
         bcc fl8_exit_6
         sbc+1 dy
         bcc fl8_exit_7
         lda #$ff
         jmp loop_plot+2
fl8_exit_2
         sta+1 err
         lda #$03
         jmp fl6_entry_y
fl8_exit_3
         sta+1 err
         lda #$07
         jmp fl5_entry_y
fl8_exit_4
         sta+1 err
         lda #$0f
         jmp fl4_entry_y
fl8_exit_5
         sta+1 err
         lda #$1f
         jmp fl3_entry_y
fl8_exit_6
         sta+1 err
         lda #$3f
         jmp fl2_entry_y
fl8_exit_7
         lda #$7f
         jmp fl1_entry_y
fl8_exit_1
         sta+1 err
         lda #$01

fl7_entry_y
         ora (dst),y
         sta (dst),y
         dey
fl7_entry
         lda+1 err
         adc+1 dxdy
         bcc fl7_exit_1
         sbc+1 dy
         bcc fl7_exit_2
         sbc+1 dy
         bcc fl7_exit_3
         sbc+1 dy
         bcc fl7_exit_4
         sbc+1 dy
         bcc fl7_exit_5
         sbc+1 dy
         bcc fl7_exit_6
         lda fl8_sh7,x
         jmp loop_plot

fl7_exit_2
         sta+1 err
         lda fl8_sh2+5,x
         jmp fl5_entry_y
fl7_exit_3
         sta+1 err
         lda fl8_sh3+4,x
         jmp fl4_entry_y
fl7_exit_4
         sta+1 err
         lda fl8_sh4+3,x
         jmp fl3_entry_y
fl7_exit_5
         sta+1 err
         lda fl8_sh5+2,x
         jmp fl2_entry_y
fl7_exit_6
         lda fl8_sh6+1,x
         jmp fl1_entry_y
fl7_exit_1
         sta+1 err
         lda fl8_sh1+6,x

fl6_entry_y
         ora (dst),y
         sta (dst),y
         dey
fl6_entry
         lda+1 err
         adc+1 dxdy
         bcc fl6_exit_1
         sbc+1 dy
         bcc fl6_exit_2
         sbc+1 dy
         bcc fl6_exit_3
         sbc+1 dy
         bcc fl6_exit_4
         sbc+1 dy
         bcc fl6_exit_5
         lda fl8_sh6,x
         jmp loop_plot

fl6_exit_2
         sta+1 err
         lda fl8_sh2+4,x
         jmp fl4_entry_y
fl6_exit_3
         sta+1 err
         lda fl8_sh3+3,x
         jmp fl3_entry_y
fl6_exit_4
         sta+1 err
         lda fl8_sh4+2,x
         jmp fl2_entry_y
fl6_exit_5
         lda fl8_sh5+1,x
         jmp fl1_entry_y
fl6_exit_1
         sta+1 err
         lda fl8_sh1+5,x

fl5_entry_y
         ora (dst),y
         sta (dst),y
         dey
fl5_entry
         lda+1 err
         adc+1 dxdy
         bcc fl5_exit_1
         sbc+1 dy
         bcc fl5_exit_2
         sbc+1 dy
         bcc fl5_exit_3
         sbc+1 dy
         bcc fl5_exit_4
         lda fl8_sh5,x
         jmp loop_plot

fl5_exit_2
         sta+1 err
         lda fl8_sh2+3,x
         jmp fl3_entry_y
fl5_exit_3
         sta+1 err
         lda fl8_sh3+2,x
         jmp fl2_entry_y
fl5_exit_4
         lda fl8_sh4+1,x
         jmp fl1_entry_y
fl5_exit_1
         sta+1 err
         lda fl8_sh1+4,x

fl4_entry_y
         ora (dst),y
         sta (dst),y
         dey
fl4_entry
         lda+1 err
         adc+1 dxdy
         bcc fl4_exit_1
         sbc+1 dy
         bcc fl4_exit_2
         sbc+1 dy
         bcc fl4_exit_3
         lda fl8_sh4,x
         jmp loop_plot

fl4_exit_2
         sta+1 err
         lda fl8_sh2+2,x
         jmp fl2_entry_y
fl4_exit_3
         lda fl8_sh3+1,x
         jmp fl1_entry_y
fl4_exit_1
         sta+1 err
         lda fl8_sh1+3,x

fl3_entry_y
         ora (dst),y
         sta (dst),y
         dey
fl3_entry
         lda+1 err
         adc+1 dxdy
         bcc fl3_exit_1
         sbc+1 dy
         bcc fl3_exit_2
         lda fl8_sh3,x
         jmp loop_plot

fl3_exit_2
         lda fl8_sh2+1,x
         jmp fl1_entry_y
fl3_exit_1
         sta+1 err
         lda fl8_sh1+2,x

fl2_entry_y
         ora (dst),y
         sta (dst),y
         dey
fl2_entry
         lda+1 err
         adc+1 dxdy
         bcc fl2_exit_1
         lda fl8_sh2,x
         jmp loop_plot

fl2_exit_1
         lda fl8_sh1+1,x
fl1_entry_y
         ora (dst),y
         sta (dst),y
         dey
fl1_entry
         lda fl8_sh1,x
         jmp loop_plot






fil8_entry
         lda+1 err
         sbc+1 dy
         bcc fil8_exit_1
         sbc+1 dy
         bcc fil8_exit_2
         sbc+1 dy
         bcc fil8_exit_3
         sbc+1 dy
         bcc fil8_exit_4
         sbc+1 dy
         bcc fil8_exit_5
         sbc+1 dy
         bcc fil8_exit_6
         sbc+1 dy
         bcc fil8_exit_7
         lda #$ff
         jmp loop_plot+2
fil8_exit_2
         sta+1 err
         lda #$c0
         jmp fil6_entry_y
fil8_exit_3
         sta+1 err
         lda #$e0
         jmp fil5_entry_y
fil8_exit_4
         sta+1 err
         lda #$f0
         jmp fil4_entry_y
fil8_exit_5
         sta+1 err
         lda #$f8
         jmp fil3_entry_y
fil8_exit_6
         sta+1 err
         lda #$fc
         jmp fil2_entry_y
fil8_exit_7
         lda #$fe
         jmp fil1_entry_y
fil8_exit_1
         sta+1 err
         lda #$80

fil7_entry_y
         ora (dst),y
         sta (dst),y
         dey
fil7_entry
         lda+1 err
         adc+1 dxdy
         bcc fil7_exit_1
         sbc+1 dy
         bcc fil7_exit_2
         sbc+1 dy
         bcc fil7_exit_3
         sbc+1 dy
         bcc fil7_exit_4
         sbc+1 dy
         bcc fil7_exit_5
         sbc+1 dy
         bcc fil7_exit_6
         lda fil8_sh7,x
         jmp loop_plot

fil7_exit_2
         sta+1 err
         lda fil8_sh2-5,x
         jmp fil5_entry_y
fil7_exit_3
         sta+1 err
         lda fil8_sh3-4,x
         jmp fil4_entry_y
fil7_exit_4
         sta+1 err
         lda fil8_sh4-3,x
         jmp fil3_entry_y
fil7_exit_5
         sta+1 err
         lda fil8_sh5-2,x
         jmp fil2_entry_y
fil7_exit_6
         lda fil8_sh6-1,x
         jmp fil1_entry_y
fil7_exit_1
         sta+1 err
         lda fil8_sh1-6,x

fil6_entry_y
         ora (dst),y
         sta (dst),y
         dey
fil6_entry
         lda+1 err
         adc+1 dxdy
         bcc fil6_exit_1
         sbc+1 dy
         bcc fil6_exit_2
         sbc+1 dy
         bcc fil6_exit_3
         sbc+1 dy
         bcc fil6_exit_4
         sbc+1 dy
         bcc fil6_exit_5
         lda fil8_sh6,x
         jmp loop_plot

fil6_exit_2
         sta+1 err
         lda fil8_sh2-4,x
         jmp fil4_entry_y
fil6_exit_3
         sta+1 err
         lda fil8_sh3-3,x
         jmp fil3_entry_y
fil6_exit_4
         sta+1 err
         lda fil8_sh4-2,x
         jmp fil2_entry_y
fil6_exit_5
         lda fil8_sh5-1,x
         jmp fil1_entry_y
fil6_exit_1
         sta+1 err
         lda fil8_sh1-5,x

fil5_entry_y
         ora (dst),y
         sta (dst),y
         dey
fil5_entry
         lda+1 err
         adc+1 dxdy
         bcc fil5_exit_1
         sbc+1 dy
         bcc fil5_exit_2
         sbc+1 dy
         bcc fil5_exit_3
         sbc+1 dy
         bcc fil5_exit_4
         lda fil8_sh5,x
         jmp loop_plot

fil5_exit_2
         sta+1 err
         lda fil8_sh2-3,x
         jmp fil3_entry_y
fil5_exit_3
         sta+1 err
         lda fil8_sh3-2,x
         jmp fil2_entry_y
fil5_exit_4
         lda fil8_sh4-1,x
         jmp fil1_entry_y
fil5_exit_1
         sta+1 err
         lda fil8_sh1-4,x

fil4_entry_y
         ora (dst),y
         sta (dst),y
         dey
fil4_entry
         lda+1 err
         adc+1 dxdy
         bcc fil4_exit_1
         sbc+1 dy
         bcc fil4_exit_2
         sbc+1 dy
         bcc fil4_exit_3
         lda fil8_sh4,x
         jmp loop_plot

fil4_exit_2
         sta+1 err
         lda fil8_sh2-2,x
         jmp fil2_entry_y
fil4_exit_3
         lda fil8_sh3-1,x
         jmp fil1_entry_y
fil4_exit_1
         sta+1 err
         lda fil8_sh1-3,x

fil3_entry_y
         ora (dst),y
         sta (dst),y
         dey
fil3_entry
         lda+1 err
         adc+1 dxdy
         bcc fil3_exit_1
         sbc+1 dy
         bcc fil3_exit_2
         lda fil8_sh3,x
         jmp loop_plot

fil3_exit_2
         lda fil8_sh2-1,x
         jmp fil1_entry_y
fil3_exit_1
         sta+1 err
         lda fil8_sh1-2,x

fil2_entry_y
         ora (dst),y
         sta (dst),y
         dey
fil2_entry
         lda+1 err
         adc+1 dxdy
         bcc fil2_exit_1
         lda fil8_sh2,x
         jmp loop_plot

fil2_exit_1
         lda fil8_sh1-1,x
fil1_entry_y
         ora (dst),y
         sta (dst),y
         dey
fil1_entry
         lda fil8_sh1,x
         jmp loop_plot


!align 255,0
fl8_tab
         !word fl8_entry+4
         !word fl7_entry+4
         !word fl6_entry+4
         !word fl5_entry+4
         !word fl4_entry+4
         !word fl3_entry+4
         !word fl2_entry+4
         !word fl1_entry
fil8_tab
         !word fil1_entry
         !word fil2_entry+4
         !word fil3_entry+4
         !word fil4_entry+4
         !word fil5_entry+4
         !word fil6_entry+4
         !word fil7_entry+4
         !word fil8_entry+4

;fl8_sh8
;fil8_sh8 = * - 7
;!byte $ff
fl8_sh7
fil8_sh7 = * - 6
          !byte $fe,$7f
fl8_sh6
fil8_sh6 = * - 5
          !byte $fc,$7e,$3f
fl8_sh5
fil8_sh5 = * - 4
          !byte $f8,$7c,$3e,$1f
fl8_sh4
fil8_sh4 = * - 3
          !byte $f0,$78,$3c,$1e,$0f
fl8_sh3
fil8_sh3 = * - 2
          !byte $e0,$70,$38,$1c,$0e,$07
fl8_sh2
fil8_sh2 = * - 1
          !byte $c0,$60,$30,$18,$0c,$06,$03
fl8_sh1
fil8_sh1 = * - 0
          !byte $80,$40,$20,$10,$08,$04,$02,$01

;---------------------------------------
; all kind of tables
;---------------------------------------

!align 255,0
;pointers into unrolled code
pixtab
         ;entrypoints f_line_dec
         !word f1_entry+3
         !word f2_entry+3
         !word f3_entry+3
         !word f4_entry+3
         !word f5_entry+3
         !word f6_entry+3
         !word f7_entry+3
         !word f8_entry+3

         ;entrypoints f_line_dec last block
         !word fl1_entry
         !word fl2_entry+4
         !word fl3_entry+4
         !word fl4_entry+4
         !word fl5_entry+4
         !word fl6_entry+4
         !word fl7_entry+4
         !word fl8_entry+4

         ;entrypoints f_line_inc
         !word fi8_entry+3
         !word fi7_entry+3
         !word fi6_entry+3
         !word fi5_entry+3
         !word fi4_entry+3
         !word fi3_entry+3
         !word fi2_entry+3
         !word fi1_entry+3

         ;entrypoints f_line_inc last block
         !word fil1_entry
         !word fil2_entry+4
         !word fil3_entry+4
         !word fil4_entry+4
         !word fil5_entry+4
         !word fil6_entry+4
         !word fil7_entry+4
         !word fil8_entry+4

;---------------------------------------
; chunks with which to enter
;---------------------------------------
!align 255,0
mask
         !byte $80,$40,$20,$10,$08,$04,$02,$01
         !byte $80,$40,$20,$10,$08,$04,$02,$01
         !byte $80,$40,$20,$10,$08,$04,$02,$01
         !byte $80,$40,$20,$10,$08,$04,$02,$01
         !byte $80,$40,$20,$10,$08,$04,$02,$01
         !byte $80,$40,$20,$10,$08,$04,$02,$01
         !byte $80,$40,$20,$10,$08,$04,$02,$01
         !byte $80,$40,$20,$10,$08,$04,$02,$01
         !byte $80,$40,$20,$10,$08,$04,$02,$01
         !byte $80,$40,$20,$10,$08,$04,$02,$01
         !byte $80,$40,$20,$10,$08,$04,$02,$01
         !byte $80,$40,$20,$10,$08,$04,$02,$01
         !byte $80,$40,$20,$10,$08,$04,$02,$01
         !byte $80,$40,$20,$10,$08,$04,$02,$01
         !byte $80,$40,$20,$10,$08,$04,$02,$01
         !byte $80,$40,$20,$10,$08,$04,$02,$01

!align 127,0
xposl
         !byte $00,$00,$00,$00,$00,$00,$00,$00
         !byte $80,$80,$80,$80,$80,$80,$80,$80
         !byte $00,$00,$00,$00,$00,$00,$00,$00
         !byte $80,$80,$80,$80,$80,$80,$80,$80
         !byte $00,$00,$00,$00,$00,$00,$00,$00
         !byte $80,$80,$80,$80,$80,$80,$80,$80
         !byte $00,$00,$00,$00,$00,$00,$00,$00
         !byte $80,$80,$80,$80,$80,$80,$80,$80
         !byte $00,$00,$00,$00,$00,$00,$00,$00
         !byte $80,$80,$80,$80,$80,$80,$80,$80
         !byte $00,$00,$00,$00,$00,$00,$00,$00
         !byte $80,$80,$80,$80,$80,$80,$80,$80
         !byte $00,$00,$00,$00,$00,$00,$00,$00
         !byte $80,$80,$80,$80,$80,$80,$80,$80
         !byte $00,$00,$00,$00,$00,$00,$00,$00
         !byte $80,$80,$80,$80,$80,$80,$80,$80

!align 127,0
xposh
         !byte $00+>bank1,$00+>bank1,$00+>bank1,$00+>bank1,$00+>bank1,$00+>bank1,$00+>bank1,$00+>bank1
         !byte $00+>bank1,$00+>bank1,$00+>bank1,$00+>bank1,$00+>bank1,$00+>bank1,$00+>bank1,$00+>bank1
         !byte $01+>bank1,$01+>bank1,$01+>bank1,$01+>bank1,$01+>bank1,$01+>bank1,$01+>bank1,$01+>bank1
         !byte $01+>bank1,$01+>bank1,$01+>bank1,$01+>bank1,$01+>bank1,$01+>bank1,$01+>bank1,$01+>bank1
         !byte $02+>bank1,$02+>bank1,$02+>bank1,$02+>bank1,$02+>bank1,$02+>bank1,$02+>bank1,$02+>bank1
         !byte $02+>bank1,$02+>bank1,$02+>bank1,$02+>bank1,$02+>bank1,$02+>bank1,$02+>bank1,$02+>bank1
         !byte $03+>bank1,$03+>bank1,$03+>bank1,$03+>bank1,$03+>bank1,$03+>bank1,$03+>bank1,$03+>bank1
         !byte $03+>bank1,$03+>bank1,$03+>bank1,$03+>bank1,$03+>bank1,$03+>bank1,$03+>bank1,$03+>bank1
         !byte $04+>bank1,$04+>bank1,$04+>bank1,$04+>bank1,$04+>bank1,$04+>bank1,$04+>bank1,$04+>bank1
         !byte $04+>bank1,$04+>bank1,$04+>bank1,$04+>bank1,$04+>bank1,$04+>bank1,$04+>bank1,$04+>bank1
         !byte $05+>bank1,$05+>bank1,$05+>bank1,$05+>bank1,$05+>bank1,$05+>bank1,$05+>bank1,$05+>bank1
         !byte $05+>bank1,$05+>bank1,$05+>bank1,$05+>bank1,$05+>bank1,$05+>bank1,$05+>bank1,$05+>bank1
         !byte $06+>bank1,$06+>bank1,$06+>bank1,$06+>bank1,$06+>bank1,$06+>bank1,$06+>bank1,$06+>bank1
         !byte $06+>bank1,$06+>bank1,$06+>bank1,$06+>bank1,$06+>bank1,$06+>bank1,$06+>bank1,$06+>bank1
         !byte $07+>bank1,$07+>bank1,$07+>bank1,$07+>bank1,$07+>bank1,$07+>bank1,$07+>bank1,$07+>bank1
         !byte $07+>bank1,$07+>bank1,$07+>bank1,$07+>bank1,$07+>bank1,$07+>bank1,$07+>bank1,$07+>bank1

         !byte $00+>bank2,$00+>bank2,$00+>bank2,$00+>bank2,$00+>bank2,$00+>bank2,$00+>bank2,$00+>bank2
         !byte $00+>bank2,$00+>bank2,$00+>bank2,$00+>bank2,$00+>bank2,$00+>bank2,$00+>bank2,$00+>bank2
         !byte $01+>bank2,$01+>bank2,$01+>bank2,$01+>bank2,$01+>bank2,$01+>bank2,$01+>bank2,$01+>bank2
         !byte $01+>bank2,$01+>bank2,$01+>bank2,$01+>bank2,$01+>bank2,$01+>bank2,$01+>bank2,$01+>bank2
         !byte $02+>bank2,$02+>bank2,$02+>bank2,$02+>bank2,$02+>bank2,$02+>bank2,$02+>bank2,$02+>bank2
         !byte $02+>bank2,$02+>bank2,$02+>bank2,$02+>bank2,$02+>bank2,$02+>bank2,$02+>bank2,$02+>bank2
         !byte $03+>bank2,$03+>bank2,$03+>bank2,$03+>bank2,$03+>bank2,$03+>bank2,$03+>bank2,$03+>bank2
         !byte $03+>bank2,$03+>bank2,$03+>bank2,$03+>bank2,$03+>bank2,$03+>bank2,$03+>bank2,$03+>bank2
         !byte $04+>bank2,$04+>bank2,$04+>bank2,$04+>bank2,$04+>bank2,$04+>bank2,$04+>bank2,$04+>bank2
         !byte $04+>bank2,$04+>bank2,$04+>bank2,$04+>bank2,$04+>bank2,$04+>bank2,$04+>bank2,$04+>bank2
         !byte $05+>bank2,$05+>bank2,$05+>bank2,$05+>bank2,$05+>bank2,$05+>bank2,$05+>bank2,$05+>bank2
         !byte $05+>bank2,$05+>bank2,$05+>bank2,$05+>bank2,$05+>bank2,$05+>bank2,$05+>bank2,$05+>bank2
         !byte $06+>bank2,$06+>bank2,$06+>bank2,$06+>bank2,$06+>bank2,$06+>bank2,$06+>bank2,$06+>bank2
         !byte $06+>bank2,$06+>bank2,$06+>bank2,$06+>bank2,$06+>bank2,$06+>bank2,$06+>bank2,$06+>bank2
         !byte $07+>bank2,$07+>bank2,$07+>bank2,$07+>bank2,$07+>bank2,$07+>bank2,$07+>bank2,$07+>bank2
         !byte $07+>bank2,$07+>bank2,$07+>bank2,$07+>bank2,$07+>bank2,$07+>bank2,$07+>bank2,$07+>bank2

!align 127,0
and7asl
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e
         !byte $00,$02,$04,$06,$08,$0a,$0c,$0e

!align 127,0
and7asl2
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e
         !byte $20,$22,$24,$26,$28,$2a,$2c,$2e

!align 127,0
bl_tab
         !byte $00,$00,$00,$00,$00,$00,$00,$00
         !byte $01,$01,$01,$01,$01,$01,$01,$01
         !byte $02,$02,$02,$02,$02,$02,$02,$02
         !byte $03,$03,$03,$03,$03,$03,$03,$03
         !byte $04,$04,$04,$04,$04,$04,$04,$04
         !byte $05,$05,$05,$05,$05,$05,$05,$05
         !byte $06,$06,$06,$06,$06,$06,$06,$06
         !byte $07,$07,$07,$07,$07,$07,$07,$07
         !byte $08,$08,$08,$08,$08,$08,$08,$08
         !byte $09,$09,$09,$09,$09,$09,$09,$09
         !byte $0a,$0a,$0a,$0a,$0a,$0a,$0a,$0a
         !byte $0b,$0b,$0b,$0b,$0b,$0b,$0b,$0b
         !byte $0c,$0c,$0c,$0c,$0c,$0c,$0c,$0c
         !byte $0d,$0d,$0d,$0d,$0d,$0d,$0d,$0d
         !byte $0e,$0e,$0e,$0e,$0e,$0e,$0e,$0e
         !byte $0f,$0f,$0f,$0f,$0f,$0f,$0f,$0f
         !byte $10,$10,$10,$10,$10,$10,$10,$10

wave_x
         ;XXX TODO movement table for x goes here
wave_y
         ;XXX TODO movement table for y goes here

scr_tab
         !byte $00,$28,$50,$78,$a0,$c8,$f0

cl_01    !byte $00,$00,$10,$20,$30,$40,$50,$60,$70,$80,$90,$a0,$b0,$c0,$d0,$e0,$f0,$00


left_t   !byte $0f,$0e,$0d,$0c,$0b,$0a,$09,$08,$07,$06, $05,$04,$03,$02,$01,$00,$00,$00,$00,$00, $00,$00,$00,$00,$00,$00,$00,$00,$00,$00, $00,$00,$00,$00,$00,$00,$00,$00,$00,$00, $00,$00,$00,$00,$00,$00,$00,$00,$00,$00, $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
         !byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
         !byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
         !byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
         !byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
right_t  !byte $10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $10,$10,$10,$10,$10,$10,$10,$10,$10,$10, $0f,$0e,$0d,$0c,$0b,$0a,$09,$08,$07,$06, $05,$04,$03,$02,$01,$00,$00,$00,$00,$00
         !byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
         !byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
         !byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
         !byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00



;moves the 16x16 grid on the screen of respective bank
!macro move_bank .addr {
.offs    = $26
         lda right_t+$0e,x
         sta .end+1

         lda left_t+$10,x
         tax

         ;clear above and below 16x16 grid
         lda #$00
!for .x,10 {
         sta .addr + .offs + (.x +2) * 40 + $0,y
         sta .addr + .offs + (.x +2) * 40 + $11,y
}

         lda .end+1
         bne +
         rts
+

-
         iny
         inx
         anc #$00
         ;clear left and right
         sta .addr + .offs + 0  * 40, y
         sta .addr + .offs + 17 * 40, y

         ;draw column
         lda cl_01,x
         sta .addr + .offs + 1  * 40, y
         adc #$01
         sta .addr + .offs + 2  * 40, y
         adc #$01
         sta .addr + .offs + 3  * 40, y
         adc #$01
         sta .addr + .offs + 4  * 40, y
         adc #$01
         sta .addr + .offs + 5  * 40, y
         adc #$01
         sta .addr + .offs + 6  * 40, y
         adc #$01
         sta .addr + .offs + 7  * 40, y
         adc #$01
         sta .addr + .offs + 8  * 40, y
         adc #$01
         sta .addr + .offs + 9  * 40, y
         adc #$01
         sta .addr + .offs + 10 * 40, y
         adc #$01
         sta .addr + .offs + 11 * 40, y
         adc #$01
         sta .addr + .offs + 12 * 40, y
         adc #$01
         sta .addr + .offs + 13 * 40, y
         adc #$01
         sta .addr + .offs + 14 * 40, y
         adc #$01
         sta .addr + .offs + 15 * 40, y
         adc #$01
         sta .addr + .offs + 16 * 40, y
.end     cpx #$10
         bne -
         rts
}

update_xy

xpos     ldx #$80
ypos     ldy #$00
         lda wave_x,x
         asl
         and #$07
         ora #$08
         sta .d016+1
         lda wave_y,y
         and #$07
         ora #$10
         sta .d011+1

         ldx xpos+1
         ldy ypos+1
         lda wave_y,y
         lsr
         lsr
         lsr
         tay
         lda wave_x,x
         lsr
         lsr
         tax
         clc
         adc scr_tab,y
         tay
.last1   cpy #$80
         beq +
         sty .last1+1
         jsr move_bank1
+
         ;advance position
         inc xpos+1
         inc ypos+1
         lda ypos+1
         cmp #200
         bne +
         lda #$00
         sta ypos+1
+
         rts

move_bank1
         +move_bank $0400
irq
         sta .a+1
         stx .x+1
         sty .y+1
         lda $01
         sta .r01+1
         lda #$35
         sta $01
!ifdef MUSIC {
         jsr $1003
}
!ifdef MOVE {
         jsr update_xy
}
         dec $d019
.d016    lda #$08
         sta $d016
.d011    lda #$1b
         sta $d011
         inc fcnt
         bne +
         inc fcnt+1
+
.r01     lda #$00
         sta $01
.a       lda #$00
.x       ldx #$00
.y       ldy #$00
         rti

timer_read
         lda fcnt
         sta $0f00
         lda fcnt+1
         sta $0f01
         lda #$00
         sta fcnt
         sta fcnt+1
         rts

;--------------------------
;CLEAR
;clear screenbuffer, FAST and only necessary areas
;--------------------------

;clear only those blocks that the object rotates in (circle with a radius of 128)
;takes ~$57 rasterlines, so not much to bother about


val1     = 44
val2     = 28
val3     = 19
val4     = 13
val5     = 9
val6     = 6
val7     = 4
val8     = 4

tab_s
         !byte val1, val2, val3, val4, val5, val6, val7, val8
         !byte val8, val7, val6, val5, val4, val3, val2, val1
tab_e
         !byte 127-val1, 127-val2, 127-val3, 127-val4, 127-val5, 127-val6, 127-val7, 127-val8
         !byte 127-val8, 127-val7, 127-val6, 127-val5, 127-val4, 127-val3, 127-val2, 127-val1

gen_clear
         lda #<clear1
         sta dst
         lda #>clear1
         sta dst+1
         ldy #$00

         lda #<bank1
         sta src
         lda #>bank1
         sta src+1
         jsr make_bank

         lda dst
         sta clear2+1
         lda dst+1
         sta clear2+2

;        lda #<clear2
;        sta dst
;        lda #>clear2
;        sta dst+1
         ldy #$00

         lda #<bank2
         sta src
         lda #>bank2
         sta src+1
         jmp make_bank

make_bank
         ldx #$00
--
         lda tab_e,x
         ora src
         sta cl_lst+1
         lda tab_s,x
         ora src
         sta src
-
         lda #$8d
         sta (dst),y
         iny
         bne +
         inc dst+1
+
         lda src
         sta (dst),y
         iny
         bne +
         inc dst+1
+
         lda src+1
         sta (dst),y
         iny
         bne +
         inc dst+1
+
         inc src
         lda src
cl_lst   cmp #$00
         bne -

         and #$80
         eor #$80
         sta src
         bmi +
         inc src+1
+
         inx
         cpx #$10
         bne --

         lda #$60
         sta (dst),y
         iny
         bne +
         inc dst+1
+
         tya
         clc
         adc dst
         sta dst
         bcc +
         inc dst+1
+
         rts
clear_end

meshdata
!src "data.asm"
meshend
clear1
